    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ---------------
    028 * PlumNeedle.java
    029 * ---------------
    030 * (C) Copyright 2002-2008, by the Australian Antarctic Division and
    031 *                          Contributors.
    032 *
    033 * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035 *
    036 * Changes:
    037 * --------
    038 * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    039 * 27-Mar-2003 : Implemented Serializable (DG);
    040 * 09-Sep-2003 : Added equals() method (DG);
    041 * 08-Jun-2005 : Implemented Cloneable (DG);
    042 * 22-Nov-2007 : Implemented hashCode() (DG);
    043 *
    044 */
    045
    046package org.jfree.chart.needle;
    047
    048import java.awt.Graphics2D;
    049import java.awt.geom.Arc2D;
    050import java.awt.geom.Area;
    051import java.awt.geom.Point2D;
    052import java.awt.geom.Rectangle2D;
    053import java.io.Serializable;
    054
    055/**
    056 * A needle for use with the {@link org.jfree.chart.plot.CompassPlot} class.
    057 */
    058public class PlumNeedle extends MeterNeedle
    059                        implements Cloneable, Serializable {
    060
    061    /** For serialization. */
    062    private static final long serialVersionUID = -3082660488660600718L;
    063
    064    /**
    065     * Draws the needle.
    066     *
    067     * @param g2  the graphics device.
    068     * @param plotArea  the plot area.
    069     * @param rotate  the rotation point.
    070     * @param angle  the angle.
    071     */
    072    protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    073                              Point2D rotate, double angle) {
    074
    075        Arc2D shape = new Arc2D.Double(Arc2D.PIE);
    076        double radius = plotArea.getHeight();
    077        double halfX = plotArea.getWidth() / 2;
    078        double diameter = 2 * radius;
    079
    080        shape.setFrame(plotArea.getMinX() + halfX - radius ,
    081                       plotArea.getMinY() - radius,
    082                       diameter, diameter);
    083        radius = Math.toDegrees(Math.asin(halfX / radius));
    084        shape.setAngleStart(270 - radius);
    085        shape.setAngleExtent(2 * radius);
    086
    087        Area s = new Area(shape);
    088
    089        if ((rotate != null) && (angle != 0)) {
    090            /// we have rotation houston, please spin me
    091            getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    092            s.transform(getTransform());
    093        }
    094
    095        defaultDisplay(g2, s);
    096    }
    097
    098    /**
    099     * Tests another object for equality with this object.
    100     *
    101     * @param obj  the object to test (<code>null</code> permitted).
    102     *
    103     * @return A boolean.
    104     */
    105    public boolean equals(Object obj) {
    106        if (obj == this) {
    107            return true;
    108        }
    109        if (!(obj instanceof PlumNeedle)) {
    110            return false;
    111        }
    112        if (!super.equals(obj)) {
    113            return false;
    114        }
    115        return true;
    116    }
    117
    118    /**
    119     * Returns a hash code for this instance.
    120     *
    121     * @return A hash code.
    122     */
    123    public int hashCode() {
    124        return super.hashCode();
    125    }
    126
    127    /**
    128     * Returns a clone of this needle.
    129     *
    130     * @return A clone.
    131     *
    132     * @throws CloneNotSupportedException if the <code>PlumNeedle</code>
    133     *     cannot be cloned (in theory, this should not happen).
    134     */
    135    public Object clone() throws CloneNotSupportedException {
    136        return super.clone();
    137    }
    138
    139}